#!/bin/bash

echo "Script started" >> /home/jelastic/add-sftp-user-addon/script_output.log

# Generate random username and password
USERNAME="user$(shuf -i 10000-99999 -n 1)"
PASSWORD=$(openssl rand -base64 12)

# Append the username to the ROOT_DIRECTORY to ensure a unique home directory for each user
ROOT_DIRECTORY="/var/www/webroot/ROOT/$USERNAME"

# Check if user already exists
if id "$USERNAME" &>/dev/null; then
    echo "User $USERNAME already exists." >> /home/jelastic/add-sftp-user-addon/script_output.log
    exit 1
fi

# Create user
useradd -m -d $ROOT_DIRECTORY $USERNAME
if [ $? -ne 0 ]; then
    echo "Failed to create user $USERNAME." >> /home/jelastic/add-sftp-user-addon/script_output.log
    exit 1
fi
echo "$USERNAME:$PASSWORD" | chpasswd

# Set user's group to both litespeed and root
usermod -aG litespeed,root $USERNAME

# Adjust permissions for the user to write to the ROOT_DIRECTORY
chown $USERNAME:root $ROOT_DIRECTORY
chmod 775 $ROOT_DIRECTORY

# Get the hostname
HOSTNAME=$(hostname -f)
echo "Script completed for user $USERNAME with hostname $HOSTNAME" >> /home/jelastic/add-sftp-user-addon/script_output.log
